function combo( amount )
    return ( 10 * amount ) ^ 1.1 + amount
end

function level( amount )
	if amount < 11 then	
		return 100 *  (math.floor(math.pow(amount,1.3)))
	end
	if amount < 15 then
		return (100 *  (math.floor(math.pow(amount,1.3)))) - (100 *  (math.floor(math.pow((amount-9),1.2))))
	end
	if amount < 21 then
		return (100 *  (math.floor(math.pow(amount,1.3)))) - (100 *  (math.floor(math.pow((amount-9),1.1))))
	end
	if amount < 99 then
		return (100 *  (math.floor(math.pow(amount,1.3)))) - (100 *  (math.floor(math.pow((amount-9),1.0))))
	end
	return 100 *  (math.floor(math.pow(amount,1.3)))
end

function level_survival( amount )
    if amount < 10 then	
		return 100 *  (math.floor(math.pow(amount,1.4)))
	end
	if amount < 15 then
		return (100 *  (math.floor(math.pow(amount,1.4)))) - (100 *  (math.floor(math.pow((amount-9),1.3))))
	end
	if amount < 21 then
		return (100 *  (math.floor(math.pow(amount,1.4)))) - (100 *  (math.floor(math.pow((amount-9),1.2))))
	end
	if amount < 99 then
		return (100 *  (math.floor(math.pow(amount,1.4)))) - (100 *  (math.floor(math.pow((amount-9),1.1))))
	end
	return 100 *  (math.floor(math.pow(amount,1.4)))
end

function upgrade_costs()
    local costs = { bomber = {}, bouncer = {}, gunner = {}, homer = {}, miner = {} }
    for i = 1, 10 do
        costs.bomber[ i ] = 20 * i - (10 * (i - 2))
        costs.bouncer[ i ] = 40 * (math.floor(math.pow(i,1.4)))
        costs.gunner[ i ] = 60 * (math.floor(math.pow(i,1.4)))
        costs.homer[ i ] = 120 + 80 * (math.floor(math.pow(i,1.4)))
        costs.miner[ i ] = 150 + 100 * (math.floor(math.pow(i,1.4)))
    end
    return costs
end

function enemies_per_minute()
    local count = { bomber = {}, bouncer = {}, gunner = {}, homer = {}, miner = {} }
    for i = 1, 6 do
        count.bomber[ i ] = 3 * i
        count.bouncer[ i ] = 2 * i
        count.gunner[ i ] = 2 * i
        count.homer[ i ] = 1 * i
        count.miner[ i ] = 1 * i
    end
    for i = 7, 10 do
        count.bomber[ i ] = 6 + count.bomber[ i - 1 ]
        count.bouncer[ i ] = 5 + count.bouncer[ i - 1 ]
        count.gunner[ i ] = 3 + count.gunner[ i - 1 ]
        count.homer[ i ] = 2 + count.homer[ i - 1 ]
        count.miner[ i ] = 3 + count.miner[ i - 1 ]
    end
    return count
end

function fuel_upgrade_cost( current_level )
    if current_level < 9 then
		return 100 + 50 *  (math.floor(math.pow(current_level,1.3)))
	end
	return ((100 + 50 *  (math.floor(math.pow(current_level,1.3)))) - (50 * (current_level - 8)))
end

function doodle_spawn_closure()
    local next_spawn = 0
    local enemy_count = 0
    local enemies = { 'Bomber', 'Bouncer', 'Gunner', 'Homer' }
    return function( elapsed_time_seconds )
        if elapsed_time_seconds >= next_spawn then
            next_spawn = next_spawn + .5
            enemy_count = enemy_count + 1
            LEVEL_MANAGER:SpawnEnemy( enemies[ math.random( #enemies ) ], 50 + enemy_count * 75 )
        end
    end
end

doodle_spawn = doodle_spawn_closure()
