float4x4
    ProjectionMatrix;
float4x4
    ModelViewMatrix;

// ~~

struct VS_TEXTURED_INPUT
{
    float2 Position : POSITION;
    float2 TextureCoordinate : TEXCOORD0;
    float4 Color : COLOR0;
};

struct VS_TEXTURED_OUTPUT
{
    float4 Position : POSITION;
    float2 TextureCoordinate : TEXCOORD0;
    float4 Color: COLOR0;
};

Texture DiffuseTexture;

sampler2D DiffuseTextureSampler
{
  Texture = <DiffuseTexture>;
};

// ~~

VS_TEXTURED_OUTPUT vs_main(
    VS_TEXTURED_INPUT input
    )
{
    VS_TEXTURED_OUTPUT
        output;
    float4x4
        wvp;

    wvp = mul( ModelViewMatrix, ProjectionMatrix );

    output.Position = mul( float4( input.Position, 0, 1 ), wvp );
    output.TextureCoordinate = input.TextureCoordinate;

    output.Color = input.Color;
    return output;
}

// ~~

VS_TEXTURED_OUTPUT vs_main_2d(
    VS_TEXTURED_INPUT input
    )
{
    VS_TEXTURED_OUTPUT
        output;

    output.Position = mul( float4( input.Position, 0, 1 ), ProjectionMatrix );
    output.TextureCoordinate = input.TextureCoordinate;

    output.Color = input.Color;
    return output;
}

// ~~

float4 ps_main(
   float2 texture_coordinate : TEXCOORD0,
   float4 color : COLOR0
   ) : COLOR0
{
    return color * tex2D( DiffuseTextureSampler, texture_coordinate ); 
}

// ~~

technique Default
{
    pass P0
    {
        VertexShader = compile vs_3_0 vs_main();
        PixelShader = compile ps_3_0 ps_main();
    }
}

// ~~

technique Default2D
{
    pass P0
    {
        VertexShader = compile vs_3_0 vs_main_2d();
        PixelShader = compile ps_3_0 ps_main();
    }
}
