
// -- TYPES

struct VS_INPUT
{
    float2 Position : POSITION;   
    float2 TexCoord : TEXCOORD0;
};

// ~~

struct VS_OUTPUT
{
    float4 Position : POSITION;
    float2 TexCoord : TEXCOORD0;    
};

// ~~

struct PS_INPUT
{
    float2 TexCoord : TEXCOORD0;
};

// -- CONSTANTS

float2 ScreenSize;

texture2D DiffuseTexture;
sampler2D DiffuseTextureSampler = sampler_state
{
    Texture = <DiffuseTexture>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU = CLAMP;
    AddressV = CLAMP;
};

// -- FUNCTIONS

VS_OUTPUT VSMain(
    const VS_INPUT input
    )
{
    VS_OUTPUT
        output;
    float4x4
		world_projection;
		
	output.TexCoord = input.TexCoord;
    output.Position = float4( 2.0 * input.Position / ScreenSize - 1.0, 0, 1 );
        
    return output;
}

// ~~

float4 PSMain(
    const PS_INPUT input
    ) : COLOR0
{
    return tex2D( DiffuseTextureSampler, input.TexCoord );
}

// ~~

technique Default
{
    pass P0
    {
        VertexShader = compile vs_3_0 VSMain();
        PixelShader = compile ps_3_0 PSMain();
    }
}
